import 'package:flutter/material.dart';
import 'square_model.dart';
import 'constants.dart';
import 'package:chessjs/pieces.dart';

/// List of each square and their states

class ChessboardModel extends ChangeNotifier {
  ChessboardModel() {
    /// Initialize square names for the chessboard
    /// The state of the square would be set by the controller
    List<Square> board = [];
    squareList.expand((element) => element).forEach((square) {
      board.add(Square(squareName: square));
    });
    this._squares = board;
  }
  late List<Square> _squares;

  List<Square> get squares => _squares;

  updateSquareState(String squareName, Piece? state) {
    _squares
        .firstWhere((square) => squareName == square.squareName)
        .squareState = state;
    notifyListeners();
  }
}
